Description

I'm observing the following (on 3.4.4 and master, Linux and Windows):

if the table of attributes has a large number of columns (63 in my case), then operations like opening the table and pasting features is

MUCH slower if compared to the same data loaded in QGIS 2.18.

My test scenario is a PostGIS layer (both client and server are on very fast connections) which has only a hand full (~4000) of small

polygons (none larger than 80ha with no more than 600 vertexes, but much less on average).

Associated revisions

Revision 4f30a44b - 2019-02-20 03:02 PM - Alessandro Pasotti

Postgis: cache information about enum fields

This is called several times and can slow down substantially

the opening of the attribute table.

Partially fixes #21303  (down from ~30 to ~6 seconds on a remote

connection)

The remaining ~4 seconds (compared to ~2 seconds in 2.18) are due

to the check for enums and provider-side  constraints, that were

not implemented in 2.18.

See: QgsEnumerationWidgetFactory::fieldScore and the call to

enumValues for details, fieldScore is called several times

because QgsAttributeTableModel::loadAttributes is also

called multiple times and it queries for widget configuration

all the times.

History

#1 - 2019-02-18 03:37 PM - Giovanni Manghi

pasting new features (copied from an identical layer) is also unbearably slow, on QGIS 2.18 is done in very quick way (saving afterwards can be slow on

both versions, depending on how many features were pasted).
#2 - 2019-02-18 03:48 PM - Giovanni Manghi

If the number of columns is reduced (like ~10) then opening the table operation do work at an acceptable speed, while pasting features remains VERY slow

even if the copy operation was done on similar/equal layer with just a few columns.

#3 - 2019-02-18 04:54 PM - Alessandro Pasotti

Confirmed

#4 - 2019-02-18 04:58 PM - Giovanni Manghi

- Subject changed from very noticeable slowdown in table of attributes operations if the table as a large number of columns to very noticeable slowdown 

in table of attributes operations if the table has a large number of columns

#5 - 2019-02-18 06:00 PM - Alessandro Pasotti

Can you split the ticket in two?

I've found the bottleneck for the paste slowdown issue, but the opening slowdown is completely unrelated.

#6 - 2019-02-18 06:02 PM - Giovanni Manghi

Alessandro Pasotti wrote:

Can you split the ticket in two?

I've found the bottleneck for the paste slowdown issue, but the opening slowdown is completely unrelated.

sure

#7 - 2019-02-18 06:04 PM - Giovanni Manghi

- Subject changed from very noticeable slowdown in table of attributes operations if the table has a large number of columns to very noticeable 

slowdown when opening the attributes table if the table has a large number of columns

#8 - 2019-02-20 08:02 AM - Alessandro Pasotti

- Status changed from Open to Feedback

I cannot reproduce with a (localhost) PG table with 4000 records and 100 columns, maybe you could share a project and data?

#9 - 2019-02-20 11:07 AM - Giovanni Manghi

- Status changed from Feedback to Open

Alessandro Pasotti wrote:

I cannot reproduce with a (localhost) PG table with 4000 records and 100 columns, maybe you could share a project and data?
test project sent privately.

#10 - 2019-02-20 11:29 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#11 - 2019-02-20 03:11 PM - Alessandro Pasotti

- Status changed from Open to In Progress

- Pull Request or Patch supplied changed from No to Yes

- Resolution set to fixed/implemented

from 30 secs to 6 secs: https://github.com/qgis/QGIS/pull/9219

There is no room for substancial further speed improvements because of the new checks for enums that need to happen at least once.

#12 - 2019-02-20 03:12 PM - Alessandro Pasotti

- Subject changed from very noticeable slowdown when opening the attributes table if the table has a large number of columns to Postgis: very 

noticeable slowdown when opening the attributes table if the table has a large number of columns

#13 - 2019-02-21 08:31 AM - Alessandro Pasotti

- Status changed from In Progress to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|4f30a44be2d59a00169da8ba982d0e95d8e9e2a2.
